import os
import shutil
import math

def main():
    try:
        os.remove("step.mcfunction")
        shutil.rmtree("binmove")
    except:
        pass
    os.mkdir("binmove")

    f = open("step.mcfunction", "w+")

    f.write("scoreboard players remove @s steps 1\n")

    f.write("stats entity @s set SuccessCount @s success\n")

    f.write("scoreboard players set @s success 0\n")
    f.write("testforblock ~ ~ ~ minecraft:air\n")
    f.write("scoreboard players set @s[score_success=0] steps 0\n")

    f.write("scoreboard players set @s success 0\n")
    f.write("scoreboard players tag @e[r=1,type=!player,tag=!ray] add selected\n")
    f.write("scoreboard players set @s[score_success_min=1] steps 0\n")
    f.write("execute @s[score_steps_min=0,score_steps=0] ~ ~ ~ /summon armor_stand ~ ~ ~ {Tags:["raypoint"],NoGravity:1b,Invulnerable:1b,Invisible:1b}")
    f.write("execute @s[score_steps_min=0,score_steps=0] ~ ~ ~ /kill @s\n")

    f.write("particle happyVillager ~ ~ ~ 0 0 0 1\n")

    split_x(range(-1000,1001),f)
    split_y(range(-1000,1001),f)
    split_z(range(-1000,1001),f)

    f.write("execute @s[score_steps_min=1] ~ ~ ~ /function raycast:step\n")

    f.close()




def split_x(arr,f):
    if(len(arr) <= 10):
        for n in arr:
            f.write("tp @s[score_x_min="+str(n)+",score_x="+str(n)+"] ~"+str(n/1000)+" ~ ~\n")
        f.close()
        return
    else:
        a = str(arr[0])
        b = str(arr[:len(arr)//2][-1])
        c = str(arr[len(arr)//2:][0])
        d = str(arr[-1])
        name_1 = "binmove/x"+ a + "_" + b
        f_1 = open(name_1 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_1+" if @s[score_x_min="+ a +",score_x="+ b +"]\n")

        split_x(arr[:len(arr)//2],f_1)

        name_2 = "binmove/x"+ c + "_" + d
        f_2 = open(name_2 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_2+" if @s[score_x_min="+ c +",score_x="+ d +"]\n")

        split_x(arr[len(arr)//2:],f_2)

def split_y(arr,f):
    if(len(arr) <= 10):
        for n in arr:
            f.write("tp @s[score_y_min="+str(n)+",score_y="+str(n)+"] ~ ~"+str(n/1000)+" ~\n")
        f.close()
        return
    else:
        a = str(arr[0])
        b = str(arr[:len(arr)//2][-1])
        c = str(arr[len(arr)//2:][0])
        d = str(arr[-1])
        name_1 = "binmove/y"+ a + "_" + b
        f_1 = open(name_1 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_1+" if @s[score_y_min="+ a +",score_y="+ b +"]\n")

        split_y(arr[:len(arr)//2],f_1)

        name_2 = "binmove/y"+ c + "_" + d
        f_2 = open(name_2 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_2+" if @s[score_y_min="+ c +",score_y="+ d +"]\n")

        split_y(arr[len(arr)//2:],f_2)

def split_z(arr,f):
    if(len(arr) <= 10):
        for n in arr:
            f.write("tp @s[score_z_min="+str(n)+",score_z="+str(n)+"] ~ ~ ~"+str(n/1000)+"\n")
        f.close()
        return
    else:
        a = str(arr[0])
        b = str(arr[:len(arr)//2][-1])
        c = str(arr[len(arr)//2:][0])
        d = str(arr[-1])
        name_1 = "binmove/z"+ a + "_" + b
        f_1 = open(name_1 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_1+" if @s[score_z_min="+ a +",score_z="+ b +"]\n")

        split_z(arr[:len(arr)//2],f_1)

        name_2 = "binmove/z"+ c + "_" + d
        f_2 = open(name_2 +".mcfunction","w+")
        f.write("execute @s ~ ~ ~ /function raycast:"+name_2+" if @s[score_z_min="+ c +",score_z="+ d +"]\n")

        split_z(arr[len(arr)//2:],f_2)

main()
